/*
  STL -> Kontnerek, trolk
  
*/


#include <iostream>
#include <vector>

using namespace std;

void kiir(const string& szoveg, const vector<int>& v);

int main()
{
    const char db = 10;
    
    vector<int> vektor(db);
    // A vector osztlysablon egszekre vonatkoztatva, 
    // 10 darab nullval tlti fel a konstruktor (mert 0 az alaprtelmezett alaprtk)
    
    for(unsigned char i=0; i<vektor.size(); ++i) vektor[i] = i*i;
    kiir("A vektor tartalma: ",vektor);
    
    double atlag = 0.0;
    for(unsigned char i=0; i<vektor.size(); ++i) atlag += vektor[i];
    atlag /= vektor.size();
    cout<<"A vektor elemeinek atlaga: ";
    cout<<atlag<<endl;
    
    vektor.push_back(100);    // j bepakolsa
    vektor.push_back(121);
    
    vektor.pop_back();        // elem levtele (vgrl) (nem trli, csak mr nem tartozik a vektorhoz)
    
    kiir("A vektor tartalma: ",vektor);
    
    
    // Hozzfrs az elemekhez:
    cout<<endl<<"A vektor elso eleme: "<<vektor[0];
    cout<<endl<<"A vektor elso eleme: "<<*vektor.begin();                 // itertort ad vissza => ~mutat
    cout<<endl<<"A vektor utolso eleme: "<<vektor[vektor.size()-1];
    cout<<endl<<"A vektor utolso eleme (nem jo): "<<*vektor.end();        // 121-et adja, ami mr nem tartozik a vektorhoz!
                                                                          // .end() az utols UTNI elemet adja
    cout<<endl<<"A vektor utolso eleme: "<<*(vektor.end()-1);             // gy mr j
    cout<<endl;
    vector<int>::iterator p = vektor.begin();
    cout<<vektor[2]<<endl;
    cout<< *(p+2) <<endl;
    cout<< *(++p) <<endl;
    cout<< *(--p) <<endl;
    
    
    system("PAUSE");
    return EXIT_SUCCESS;
}

void kiir(const string& szoveg, const vector<int>& v){
     cout<<endl<<szoveg;
     
     // Itertorral jrjuk be:
     for(vector<int>::const_iterator iter=v.begin(); iter!=v.end(); ++iter){
                               cout<<*iter<<'\t';             // itertor ltal mutatott rtk
                               // a sima iterator lehetv teszi az ltala mutatott rtk mdostst,
                               // ezrt kellett const_iterator tpus
     }
     cout<<endl<<endl;
}
