/*

KONSTRUKTOR

- neve megegyezik az osztly nevvel
- visszatrsi tpusa nincs (mg void sem), visszaadott rtk sincs
- pldnyostskor hvdik meg
- feladata az objektum kezdllapotnak belltsa, inicializlsa
- tlterhelhet
- hrom tpusa van:
	- alaprtelmezett konstruktor
	- paramteres konstruktor
	- msol konstruktor

DESTRUKTOR

- neve: ~osztlynv
- visszatrsi tpusa nincs
- minden objektumra egyszer hvdik meg: az objektum "letnek vgn"
- nem terhelhet tl

*/

#include <iostream>
#include <cmath> // ez a javasolt, mert a math.h C nyelvhez van!

using namespace std;

class Pont{
    private:
        double x ,y;
    public:
     // KONSTRUKTOROK      
           
     // alaprtelmezett (default) (paramter nlkli) konstruktor:
        Pont() {x=0.0; y=0.0;}
     // Msik md: 
     // Pont() : x(0.0),y(0.0) {};      <- mindig mkdik (fels lehet h nha nem)
        
     // paramteres konstruktor:
        Pont(double xx, double yy) {x=xx; y=yy;};
     // pont.cpp-ben gy kne:
     // Pont::Pont(double xx, double yy) {x=xx; y=yy;};
     // Msik md:
     // Pont(double xx, double yy) : x(xx), y(yy) {};
     
     // msol konstruktor (egy mr meglv objektum llapott bemsolja az jba kezdrtkknt):
        Pont(const Pont &A) {x=A.x; y=A.y;}; // private ellenre hozzfrhet, mert osztlyon bell vagyunk
        // & ==> megmarad az eredeti objektum s csak a cme addik t
     // Msik md:
     // Pont(const Pont &A) : x(A.x),y(A.y) {};
        
        
        
     // DESTRUKTOR
     
        ~Pont() {};
        
        
        
        
        void setX(double xx);
        void setY(double yy);
        double getX()const;
        double getY()const;
        double dd(Pont xxx, Pont yyy);
        
        
        // 3.RA
        
        // a const a vgre azrt kell, hogy az objektum ne mdosuljon a fv. hatsra!!!
        double d(const Pont& P)const;
        double d()const;
        
        Pont felezo(const Pont& B)const;
        Pont felezo()const;
        Pont felezo(const Pont& B, double m, double n)const;
        void kiir();
        
};

// Osztlyon kvli tvolsgmrs fv.prototpusa
double dist(const Pont& A, const Pont &B);


// 3. RA
// Opertortlterhels:
ostream& operator<<(ostream& os, const Pont& P){
         os<<"( "<<P.getX()<<" , "<<P.getY()<<" )"<<endl;
         return os;
}
