#include <iostream>
#include <cmath>

using namespace std;

class Pont{
    private:
        double x ,y;
    public:
        Pont() {x=0.0; y=0.0;}
        Pont(double xx, double yy) {x=xx; y=yy;};
        Pont(const Pont &A) {x=A.x; y=A.y;};
        
        ~Pont() {};
        
        void setX(double xx);
        void setY(double yy);
        double getX()const;
        double getY()const;
        double dd(Pont xxx, Pont yyy);
        
        double d(const Pont& P)const;
        double d()const;
        
        Pont felezo(const Pont& B)const;
        Pont felezo()const;
        Pont felezo(const Pont& B, double m, double n)const;
        void kiir();
        
        //Pont& operator = (const Pont& A);
        //bool operator == (const Pont& A)const;
        //bool operator != (const Pont& A)const;
        //Pont operator + (const Pont& A)const;
        //Pont operator - (const Pont& A)const;
        //Pont operator - (const double& A)const;
        //Pont operator + (const double& A)const;
        //Pont operator * (const double& A)const;
        //Pont& operator += (const Pont& A);
        
        //Pont operator ++ ();
        //Pont& operator ++ (int);
        
        // tdik ra

        // friend: Osztlyon bell vannak deklarlva, de nem tagjai az osztlynak
        // a privt adattagokhoz val kzvetlen hozzfrst teszi lehetv        

        // ezeknek nem kell a vgre const, mert ott van bell a msodik operandusra
        
        friend Pont operator + (const Pont& A, const Pont& B);
        
        friend ostream& operator << (ostream& os, const Pont& A);
        
        // friend void operator = (Pont& A, const Pont& B);
        // (nem j, nem tlterhelhet a = !!!)
        
        friend bool operator == (const Pont& A, const Pont& B);
        
        friend void operator += (Pont& A, const Pont& B);
        
        friend Pont operator - (Pont& A, const Pont& B);
        
        friend Pont operator - (Pont& A, const double& B);
        
        friend bool operator != (const Pont& A, const Pont& B);
        
        friend Pont operator + (const Pont& A, const double& B);
        
        friend Pont operator * (const Pont& A, const double& B);
        
        friend Pont operator ++ (Pont& A);
        
        friend Pont operator ++ (Pont& A, int);
};

double dist(const Pont& A, const Pont &B);

